"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
var typescript_1 = __importDefault(require("typescript"));
var Class_1 = require("../Components/Class");
var ComponentFactory = __importStar(require("./ComponentFactory"));
function create(fileName, classSymbol, checker) {
    var result = new Class_1.Class(classSymbol.getName(), fileName);
    var classDeclaration = classSymbol.getDeclarations();
    if (classDeclaration !== undefined && classDeclaration.length > 0) {
        result.isStatic = ComponentFactory.isModifier(classDeclaration[classDeclaration.length - 1], typescript_1.default.SyntaxKind.StaticKeyword);
        result.isAbstract = ComponentFactory.isModifier(classDeclaration[classDeclaration.length - 1], typescript_1.default.SyntaxKind.AbstractKeyword);
    }
    if (classSymbol.members !== undefined) {
        result.constructorMethods = ComponentFactory.serializeConstructors(classSymbol.members, checker);
        result.members = ComponentFactory.serializeMethods(classSymbol.members, checker);
        result.typeParameters = ComponentFactory.serializeTypeParameters(classSymbol.members, checker);
    }
    if (classSymbol.exports !== undefined) {
        result.members = result.members.concat(ComponentFactory.serializeMethods(classSymbol.exports, checker));
    }
    if (classSymbol.globalExports !== undefined) {
        result.members = result.members.concat(ComponentFactory.serializeMethods(classSymbol.globalExports, checker));
    }
    if (classDeclaration !== undefined && classDeclaration.length > 0) {
        var heritageClauses = classDeclaration[classDeclaration.length - 1].heritageClauses;
        if (heritageClauses !== undefined) {
            heritageClauses.forEach(function (heritageClause) {
                if (heritageClause.token === typescript_1.default.SyntaxKind.ExtendsKeyword) {
                    var extendsClass = ComponentFactory.getHeritageClauseNames(heritageClause, checker)[0];
                    result.extendsClass = extendsClass[0];
                    result.extendsClassFile = extendsClass[1];
                }
                else if (heritageClause.token === typescript_1.default.SyntaxKind.ImplementsKeyword) {
                    var implementsInterfaces = ComponentFactory.getHeritageClauseNames(heritageClause, checker);
                    result.implementsInterfaces = implementsInterfaces.map(function (arr) { return arr[0]; });
                    result.implementsInterfacesFiles = implementsInterfaces.map(function (arr) { return arr[1]; });
                }
            });
        }
    }
    return result;
}
exports.create = create;
