"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
var typescript_1 = __importDefault(require("typescript"));
var Interface_1 = require("../Components/Interface");
var ComponentFactory = __importStar(require("./ComponentFactory"));
function create(interfaceSymbol, checker) {
    var result = new Interface_1.Interface(interfaceSymbol.getName());
    var declaration = interfaceSymbol.getDeclarations();
    if (interfaceSymbol.members !== undefined) {
        result.members = ComponentFactory.serializeMethods(interfaceSymbol.members, checker);
        result.typeParameters = ComponentFactory.serializeTypeParameters(interfaceSymbol.members, checker);
    }
    if (declaration !== undefined && declaration.length > 0) {
        var heritageClauses = declaration[declaration.length - 1].heritageClauses;
        if (heritageClauses !== undefined) {
            heritageClauses.forEach(function (heritageClause) {
                if (heritageClause.token === typescript_1.default.SyntaxKind.ExtendsKeyword) {
                    var extendsInterfaces = ComponentFactory.getHeritageClauseNames(heritageClause, checker);
                    result.extendsInterface = extendsInterfaces.map(function (arr) { return arr[0]; });
                    result.extendsInterfaceFiles = extendsInterfaces.map(function (arr) { return arr[1]; });
                }
            });
        }
    }
    return result;
}
exports.create = create;
