"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
var typescript_1 = __importDefault(require("typescript"));
var Namespace_1 = require("../Components/Namespace");
var ComponentFactory = __importStar(require("./ComponentFactory"));
function create(fileName, namespaceSymbol, checker) {
    var result = new Namespace_1.Namespace(namespaceSymbol.getName());
    var namespaceDeclarations = namespaceSymbol.getDeclarations();
    if (namespaceDeclarations === undefined) {
        return result;
    }
    var declaration = namespaceDeclarations[namespaceDeclarations.length - 1];
    if (declaration === undefined || declaration.body === undefined) {
        return result;
    }
    if (declaration.body.kind === typescript_1.default.SyntaxKind.ModuleDeclaration) {
        var childSymbol = checker.getSymbolAtLocation(declaration.body.name);
        if (childSymbol !== undefined) {
            result.parts = [create(fileName, childSymbol, checker)];
            return result;
        }
    }
    if (declaration.body.statements === undefined) {
        return result;
    }
    result.parts = ComponentFactory.create(fileName, declaration.body, checker);
    return result;
}
exports.create = create;
