"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
var typescript_1 = __importDefault(require("typescript"));
var Property_1 = require("../Components/Property");
var ComponentFactory = __importStar(require("./ComponentFactory"));
function create(signature, namedDeclaration, checker) {
    var result = new Property_1.Property(signature.getName());
    result.modifier = ComponentFactory.getMemberModifier(namedDeclaration);
    result.isAbstract = ComponentFactory.isModifier(namedDeclaration, typescript_1.default.SyntaxKind.AbstractKeyword);
    result.isOptional = ComponentFactory.isOptional(namedDeclaration);
    result.isStatic = ComponentFactory.isModifier(namedDeclaration, typescript_1.default.SyntaxKind.StaticKeyword);
    result.isReadonly = ComponentFactory.isModifier(namedDeclaration, typescript_1.default.SyntaxKind.ReadonlyKeyword);
    if (signature.valueDeclaration === undefined) {
        throw new Error("unable to determing returnType");
    }
    result.returnType = checker.typeToString(checker.getTypeOfSymbolAtLocation(signature, signature.valueDeclaration), namedDeclaration);
    return result;
}
exports.create = create;
