"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.getConstraint = void 0;
var typescript_1 = __importDefault(require("typescript"));
var TypeParameter_1 = require("../Components/TypeParameter");
var ComponentFactory = __importStar(require("./ComponentFactory"));
function getConstraint(memberDeclaration, checker) {
    var effectiveConstraint = typescript_1.default.getEffectiveConstraintOfTypeParameter(memberDeclaration);
    if (effectiveConstraint === undefined) {
        return;
    }
    return checker.getTypeFromTypeNode(effectiveConstraint);
}
exports.getConstraint = getConstraint;
function create(signature, namedDeclaration, checker) {
    var result = new TypeParameter_1.TypeParameter(signature.getName());
    if (namedDeclaration === undefined) {
        return result;
    }
    var constraintType = getConstraint(namedDeclaration, checker);
    if (constraintType !== undefined) {
        result.constraint = checker.typeToString(constraintType);
        result.constraintFile = ComponentFactory.getOriginalFileOriginalType(constraintType, checker);
    }
    return result;
}
exports.create = create;
